routes/web.php
<?php

use App\Http\Controllers\AuthController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\CheckOutController;
use App\Http\Controllers\CustomerController;
use App\Http\Controllers\HistoryController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\OrderController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\TransactionController;
use App\Http\Controllers\TransactionsController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/home', function () {
    return view('home');
})->middleware('auth')->name('home');

Route::get('/', [CustomerController::class, 'index'])->name('customer');
Route::get('list-product/{product}', [CustomerController::class, 'listProduct'])->name('listproduct.show');
Route::get('list-detail-product/{product}/{category}', [CustomerController::class, 'listDetailProduct'])->name('listdetailproduct.show');
Route::get('login', [AuthController::class, 'login'])->name('login');
Route::post('login', [AuthController::class, 'logon'])->name('logon');
Route::get('logout', [AuthController::class, 'logout'])->name('logout');
Route::get('register', [UserController::class, 'register'])->name('register');
Route::get('forgot-password', [AuthController::class, 'forgotPassword'])->name('forgot.Password');
Route::get('email', [AuthController::class, 'checkMail'])->name('checkMail');
Route::put('Change-password', [AuthController::class, 'changePassword'])->name('change.Password');

Route::group(['prefix' => 'user', 'middleware' => ['auth', 'role:'.role_user]], function () {
    Route::get('/', [HomeController::class, 'index']);
    Route::get('cart', [CartController::class, 'index'])->name('cart.index');
    Route::post('cart-store', [CartController::class, 'addcart'])->name('cart.store');
    Route::delete('cart-delete/{cart}', [CartController::class, 'destroy'])->name('cart.delete');
    Route::get('history', [HistoryController::class, 'index'])->name('history.index');
    Route::post('checkout', [CheckOutController::class, 'payment'])->name('payment');
    Route::get('payment', [CheckOutController::class, 'returnPayment'])->name('return.payment');
    Route::get('history/{history}', [HistoryController::class, 'detail'])->name('history.detail');
    Route::resource('transactions', TransactionController::class);
});

Route::group(['prefix' => 'admin', 'middleware' => ['auth', 'role:'.role_admin]], function () {

    Route::get('add-user', [UserController::class, 'addUser'])->name('add.user');
    Route::get('restore/{restore}', [CategoryController::class, 'restore'])->name('category.restore');
    Route::resource('categories', CategoryController::class);
    Route::get('listSoftDelete', [CategoryController::class, 'listSoftDelete'])->name('list.categorysoftDelete');
    Route::delete('realdelete/{realdelete}', [CategoryController::class, 'realDelete'])->name('category.realDelete');
    Route::resource('users', UserController::class);
});
Route::group(['prefix' => 'shop', 'middleware' => ['auth', 'role:'.role_shop]], function () {
    Route::get('productSoftDelete', [ProductController::class, 'listSoftDelete'])->name('product.softDelete');
    Route::get('restore/{restore}', [ProductController::class, 'restore'])->name('product.restore');
    Route::delete('realdelete/{realdelete}', [ProductController::class, 'realDelete'])->name('product.realDelete');
    Route::get('order', [OrderController::class, 'index'])->name('order.index');
    Route::put('order/{order}', [OrderController::class, 'update'])->name('order.update');
    Route::post('product-discount', [ProductController::class, 'updateDiscount'])->name('product.updateDiscount');
    Route::resource('products', ProductController::class);
});
Route::resource('users', UserController::class)->only('store');

app/Http/Controllers/AuthController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\AuthRequest;
use App\Http\Requests\ForgotPasswordRequest;
use App\Mail\SendMail;
use App\Models\Forgot_password;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;

class AuthController extends Controller
{
    private $user;
    private $forgot_password;
    public function __construct(User $user, Forgot_password $forgot_password)
    {
        $this->user = $user;
        $this->forgot_password = $forgot_password;
    }

    public function login(Request $request)
    {
        if (Auth::check()) {
            return redirect()->route('home');
        }
        return view('Auths.login');
    }
    public function logout()
    {
        Auth::logout();
        return redirect()->route('login');
    }
    public function logon(AuthRequest $request)
    {
        if (Auth::attempt([
            'username' => $request->username,
            'password' => $request->password,
        ])) {
            if (auth()->user()->role == role_user) {
                return redirect()->route('customer');
            } else {

                return redirect()->route('home');
            }
        }
        return redirect()->route('login')->with('error','Your account password is not correct');
    }
    public function forgotPassword()
    {
        return view('Auths.forgot_change_password');
    }
    public function checkMail(Request $request)
    {
        $user = $this->user->where('email', $request->email)->first();
        if ($user) {
            $token = substr(md5(rand(0, 999999)), 0, 8);
            $user->forgotPasswords()->create([
                'token' => $token,
            ]);
            $mail = new SendMail($token);
            Mail::to($request->email)->queue($mail);
        }else{
            return redirect()->route('forgot.Password')->with('error','Email does not exist');
        }
        return view('Auths.change_password');
    }

    public function changePassword(ForgotPasswordRequest $request)
    {

        $token = $this->forgot_password->whereForgotPassword($request->token)->first();
        if ($token) {

            $this->user->find($token->user_id)->update([
                'password' => $request->password,
            ]);
            $this->forgot_password->find($token->id)->delete();
            return redirect()->route('login');
        } else {
            $this->forgot_password->find($token->id)->delete();
            return redirect()->route('change.Password')->with('token' ,'Mã không đúng');
        }
    }
}

resources/views/Auths/change_password.blade.php
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- CSS only -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-gH2yIJqKdNHPEq0n4Mqa/HGKIhSkIHeL5AyhkYV8i59U5AR6csBvApHHNl/vI1Bx" crossorigin="anonymous">
    <!-- JavaScript Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-A3rJD856KowSb7dwlZdYEkO39Gagi7vIsF0jrRAoQmDKKtQBHUuLZ9AsSv4jD4Xa" crossorigin="anonymous">
    </script>

</head>

<body>
    <div class="container d-flex justify-content-center align-items-center" style="min-height: 100vh ;">
        <form action="{{ route('change.Password') }}" class="border shadow p-3 rounded" method="post"
            style="width:400px">
            @csrf
            @method('PUT')
          
            @include('layouts.alert')
            <div class="mb-3">
                <label for="token">Mã khôi phục</label>
                <input type="token" class="form-control" id="token" placeholder="token" name="token">
            </div> 
            <div class="mb-3">
                <label for="Password">Password</label>
                <input type="password" class="form-control" id="Password" placeholder="Password" name="password">
            </div>
            @error('password')
                <p style="color: red">{{ $message }}</p>
            @enderror
            <div class="mb-3">
                <label for="confirmpassword">Confirm Password</label>
                <input type="password" class="form-control" id="confirmpassword" placeholder="Confirm password"
                    name="confirmpassword">
            </div>
            @error('confirmpassword')
                <p style="color: red">{{ $message }}</p>
            @enderror
            <div class="mb-3">
                <button type="submit" name="login" class="btn btn-primary">Submit</button>
            </div>

        </form>
    </div>
</body>

</html>

resources/views/Auths/create.blade.php
@extends('layouts.view_home')
@section('css')
@endsection
@section('content')
    <div class="content-body" style="color: black">
        <div class="card-header">
            <h3 style="color: blue" class="card-title">Create user</h3>
        </div>
        <div class="card">

            <div class="card-body">
                <form action="
                    {{ route('add.user') }}" method="GET">
                    @csrf

                    @include('components.input_sample', [
                        'name' => 'name',
                        
                    ])
                    @include('components.input_sample', [
                        'name' => 'email',
                        'type' => 'text',
                        
                    ])
                    @include('components.input_sample', [
                        'name' => 'password',
                        'type' => 'password',
                       
                    ])
                    @include('components.input_sample', [
                        'name' => 'confirmpassword',
                        'type' => 'password',
                       
                    ])
                    @include('components.input_sample', [
                        'name' => 'username',
                        'type' => 'text',
                       
                    ])
                    @include('components.input_sample', [
                        'name' => 'address',
                        'type' => 'text', 
                    ])
                   
                    @include('components.input_sample', [
                        'name' => 'phone',
                        'type' => 'text', 
                    ])
                    @include('components.input', [
                        'name' => 'role',
                        'type' => 'hidden', 
                        'attr'=>'readonly',
                        'value'=>'1'
                    ])
                    
                   
                    <button type="submit" class="ml-5 btn btn-primary">Submit</button>
                </form>
            </div>

            <div class="card-footer clearfix">

            </div>
        </div>
    </div>
@endsection

resources/views/Auths/email.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Yêu cầu thay đổi mật khẩu</title>
</head>
<body>
    <div>
        Chào bạn  Bạn đã yêu cầu thay đổi mật khẩu,mã khôi phục tài khoản của bạn là:{{$token}}
    </div>
</body>
</html>

resources/views/Auths/forgot_change_password.blade.php
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- CSS only -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-gH2yIJqKdNHPEq0n4Mqa/HGKIhSkIHeL5AyhkYV8i59U5AR6csBvApHHNl/vI1Bx" crossorigin="anonymous">
    <!-- JavaScript Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0/dist/js/bootstrap.bundle.min.js" integrity="sha384-A3rJD856KowSb7dwlZdYEkO39Gagi7vIsF0jrRAoQmDKKtQBHUuLZ9AsSv4jD4Xa" crossorigin="anonymous"></script>
   
</head>

<body>
    <div class="container d-flex justify-content-center align-items-center" style="min-height: 100vh ;">
        <form action="{{route('checkMail')}}" class="border shadow p-3 rounded" method="GET" style="width:400px">
            @csrf
            @include('layouts.alert')
            <h1 class="text-center p3">Forgot Password</h1>
            <div class="mb-3">
                <label for="Email">Email</label>
                <input type="email" class="form-control"  placeholder="Email" name="email">
            </div>
            @error('email')
                <p style="color: red">{{$message}}</p>
            @enderror
            <div class="mb-3">
                <button type="submit" name="login" class="btn btn-primary col-12">Send</button>
            </div>
                
        </form>
    </div>
</body>

</html>

resources/views/Auths/index.blade.php
@extends('layouts.view_home')
@section('css')
@endsection
@section('content')
    <div class="content-body">
        <div class="card-header">
            <h3 class="card-title" style="color: blue">Danh sách user</h3>
        </div>
        <div class="card">
            <div class="card-body">
                <div class="p-2 bd-highlight">
                    <a href="{{ route('users.create') }}" class="btn btn-success">Add</a>
                </div>
                <table id="example2" class="table" style="color: black">
                    <thead>
                        @php
                            $i = 1;
                        @endphp
                        <tr>
                            <th>STT</th>
                            <th>Name</th>
                            <th>Email</th>
                            <th>Address</th>
                            <th>Phone</th>
                        </tr>

                        @foreach ($users as $user)
                            <tr>
                                <td>{{ $i++ }}</td>
                                <td>{{ $user->name }}</td>
                                <td>{{ $user->email }}</td>
                                <td>{{ $user->address }}</td>
                                <td>{{ $user->phone }}</td>
                        @endforeach

                    <tbody>



                </table>
            </div>
        </div>
    </div>
@endsection
@section('js')
@endsection

resources/views/Auths/login.blade.php
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- CSS only -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-gH2yIJqKdNHPEq0n4Mqa/HGKIhSkIHeL5AyhkYV8i59U5AR6csBvApHHNl/vI1Bx" crossorigin="anonymous">
    <!-- JavaScript Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-A3rJD856KowSb7dwlZdYEkO39Gagi7vIsF0jrRAoQmDKKtQBHUuLZ9AsSv4jD4Xa" crossorigin="anonymous">
    </script>
    <title>Document</title>
</head>

<body>
    <div class="container d-flex justify-content-center align-items-center" style="min-height: 100vh ;">
        <form action="{{ route('logon') }}" class="border shadow p-3 rounded" method="POST" style="width:400px">
            @csrf
            @include('layouts.alert')
            <h1 class="text-center p3">LOGIN</h1>
            <div class="mb-3">
                <label for="username">Username</label>
                <input type="username" class="form-control" id="username" placeholder="Username" name="username">
            </div>
            @error('username')
                <p style="color: red">{{ $message }}</p>
            @enderror

            <div class="mb-3">
                <label for="password">Password</label>
                <input type="password" class="form-control" id="password" placeholder="Password" name="password">
            </div>
            @error('password')
                <p style="color: red">{{ $message }}</p>
            @enderror
            <div class="mb-3">
                <button type="submit" name="login" class="btn btn-primary col-12">Login</button>
            </div>
            <a class="btn btn-warning col-12" href="{{ route('register') }}">Register</a><br>
            <a href="{{ route('forgot.Password') }}">Forgot Password</a>
        </form>
    </div>
</body>

</html>

resources/views/Auths/register.blade.php
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- CSS only -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-gH2yIJqKdNHPEq0n4Mqa/HGKIhSkIHeL5AyhkYV8i59U5AR6csBvApHHNl/vI1Bx" crossorigin="anonymous">
    <!-- JavaScript Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-A3rJD856KowSb7dwlZdYEkO39Gagi7vIsF0jrRAoQmDKKtQBHUuLZ9AsSv4jD4Xa" crossorigin="anonymous">
    </script>
    <title>Document</title>
</head>

<body>
    <div class="container d-flex justify-content-center align-items-center" style="min-height: 100vh ;">
        <form action="{{ route('users.store') }}" class="border shadow p-3 rounded" method="POST" style="width:400px">
            @csrf
            <h1 class="text-center p3">REGISTER</h1>
            @include('components.input_sample', [
                'name' => 'name',
            ])
            @include('components.input_sample', [
                'name' => 'email',
                'type' => 'text',
            ])
            @include('components.input_sample', [
                'name' => 'username',
                'type' => 'text',
            ])
            @include('components.input_sample', [
                'name' => 'password',
                'type' => 'password',
            ])
            @include('components.input_sample', [
                'name' => 'confirmpassword',
                'type' => 'password',
            ])
            @include('components.input_sample', [
                'name' => 'address',
                'type' => 'text',
            ])

            @include('components.input_sample', [
                'name' => 'phone',
                'type' => 'text',
            ])
            @include('components.input', [
                'name' => 'role',
                'type' => 'hidden',
                'attr' => 'readonly',
                'value' => '1',
            ])

            <button type="submit" name="register" class="btn btn-primary">Register</button>
        </form>
    </div>
</body>

</html>